#!/bin/sh
if [ $# -eq 1 ]
   then
   CONFIG_FILE=$1
   else
   CONFIG_FILE=./config
   fi
if [ -s ${CONFIG_FILE} ]
   then
   echo "Configuration file in use is ${CONFIG_FILE}"
   else
   echo "Configuration file ${CONFIG_FILE} does not exist, exiting"
   exit 1
   fi
. ${CONFIG_FILE}
START_HOLD=${START}
INCR_HOLD=${INCR}
trap "" ${TRAPPED_SIGNALS}
for READ_PER in ${READ_PERCENTAGES}
   do
   for KB_BLK_SZ in ${KB_BLK_SIZES}
      do
      START=${START_HOLD}
      INCR=${INCR_HOLD}
      HOLD='>prev'
      echo
      echo
      echo "Random ${KB_BLK_SZ}kb ${READ_PER}% reads over ${DESC_SZ} of ${HEADER}. "
      echo "Random ${KB_BLK_SZ}kb ${READ_PER}% reads over ${DESC_SZ} of ${HEADER}. " >> ${NAME}${READ_PER}_${KB_BLK_SZ}.tot
      echo "num procs	service time	response time	     I/Os/sec        KB/sec" >> ${NAME}${READ_PER}_${KB_BLK_SZ}.tot
      echo "Number of processes $START"
      BLK_SZ=`expr ${KB_BLK_SZ} \* 1024`
      NUM_BLKS=`expr ${CAPACITY} / ${KB_BLK_SZ}`
      ${IOGEN} $START ${READ_PER} ${BLK_SZ} ${NUM_BLKS} ${ITERATIONS} ${DEVICES} >> ${NAME}${READ_PER}_${KB_BLK_SZ}.$START
      sleep 2
      ${AWK} -f count ${NAME}${READ_PER}_${KB_BLK_SZ}.${START} >> ${NAME}${READ_PER}_${KB_BLK_SZ}.tot
      #HOLD=`${AWK} -f checker -v resp_time=${RESP_TIME} ${NAME}${READ_PER}_${KB_BLK_SZ}.tot`
      rm ${NAME}${READ_PER}_${KB_BLK_SZ}.${START}
      JMP_FLAG=${INCR}
      START_OLD=${START}
      while [ $HOLD = '>prev' ]
         do
         START_OLD=${START}
         START=`expr $START + $INCR`
         echo "Number of processes $START"
         ${IOGEN} $START ${READ_PER} ${BLK_SZ} ${NUM_BLKS} ${ITERATIONS} ${DEVICES} >> ${NAME}${READ_PER}_${KB_BLK_SZ}.$START
         sleep 2
         ${AWK} -f count ${NAME}${READ_PER}_${KB_BLK_SZ}.${START}>>${NAME}${READ_PER}_${KB_BLK_SZ}.tot
         HOLD=`${AWK} -f checker -v resp_time=${RESP_TIME} ${NAME}${READ_PER}_${KB_BLK_SZ}.tot`
         rm ${NAME}${READ_PER}_${KB_BLK_SZ}.${START}
         done
      if [ $JMP_FLAG -gt 1 ]
         then
         INCR=1
         while [ ${START_OLD} -lt `expr ${START} - 1` ]
            do
            START=`expr $START - $INCR`
            echo "Number of processes $START"
            ${IOGEN} $START ${READ_PER} ${BLK_SZ} ${NUM_BLKS} ${ITERATIONS} ${DEVICES} >> ${NAME}${READ_PER}_${KB_BLK_SZ}.$START
            sleep 10
            ${AWK} -f count ${NAME}${READ_PER}_${KB_BLK_SZ}.${START}>>${NAME}${READ_PER}_${KB_BLK_SZ}.tot
            HOLD=`${AWK} -f checker -v resp_time=${RESP_TIME} ${NAME}${READ_PER}_${KB_BLK_SZ}.tot`
            rm ${NAME}${READ_PER}_${KB_BLK_SZ}.${START}
            done
         fi
      echo "Test completed"
   done
done
